close all;
img = imread('testImage.PNG');

%% Create array of sample points 
rSamp = [226,222,167,188,221,231,163,180,210,184,201,198,221,207,197,223,215,194,151,150,181,119,169,140,190,189,203,197];
gSamp = [128,123,84,84,119,134,70,73,111,95,90,108,111,107,88,112,114,102,66,68,87,44,77,53,111,105,103,111];
bSamp = [103,100,59,75,96,117,53,63,90,79,83,82,98,91,83,95,102,91,46,46,53,38,56,43,78,81,77,78];

%% Calculate mean and standard deviation
rMean = mean(mean(rSamp));
gMean = mean(mean(gSamp));
bMean = mean(mean(bSamp));

%% Set Threshold
rSTD = std(rSamp);
gSTD = std(gSamp);
bSTD = std(bSamp);

thresh = 1.2;

%% Create binary image based on threshold of all 
rLow = img(:,:,1) < rMean+rSTD*thresh;
rHigh = img(:,:,1) > rMean-rSTD*thresh;
gLow = img(:,:,2) < gMean+gSTD*thresh;
gHigh = img(:,:,2) > gMean-gSTD*thresh;
bLow = img(:,:,3) < bMean+bSTD*thresh;
bHigh = img(:,:,3) > bMean-bSTD*thresh;

imBinR = rLow .* rHigh;
imBinG = gLow .* gHigh;
imBinB = bLow .* bHigh;
imBin = imBinR .* imBinG .* imBinB;

subplot(3,1,1);
imshow(imBinR);
subplot(3,1,2);
imshow(imBinG);
subplot(3,1,3);
imshow(imBinB);
figure()

%% Pre-processing
subplot(2,1,1);
imshow(imBin);
imBin = reduceNoise(imBin);
% imBin = imBin(6:size(imBin,1)-5,6:size(imBin,2)-5);
subplot(2,1,2);
imshow(imBin);
[findObjs,num] = bwlabel(imBin);
border = 5;

figure();
imshow(img); hold on
for i = 1:num
        %% Create individual images for each object
        
        %% Create min and max for current object
        [allY,allX] = find(findObjs==i);
        maxX = max(allX)+border;
        minX = min(allX)-border;
        maxY = max(allY)+border;
        minY = min(allY)-border;
        
        %% Clip borders to edges of image
        if(minX-border<=1) minX = 1; end;
        if(minY-border<=1) minY = 1; end;
        if(maxX+border>=size(img,2)) maxX = size(img,2); end;
        if(maxY+border>=size(img,1)) maxY = size(img,1); end;
        
        bounds = struct('minX',minX,'minY',minY,'maxX',maxX,'maxY',maxY);
        
        faces{i} = img(minY:maxY,minX:maxX);
        facesBW{i} = edge(imBin(minY:maxY,minX:maxX));
        
%         subplot(1,num,i);
%         imshow(faces{i});
        
         houghEllipse(facesBW{i},img,bounds);
end
       
% figure()
% C = edge(imBin);
% imshow(C);








