function shape = houghEllipse(image,imWhole,bounds)
%% Returns vertices of a shape

%% Create grid for x&y
[Nr,Nc] = size(image);
[xo,yo]= meshgrid(1:Nc,1:Nr);

[ye, xe]= find(image==1);   % all points of edge plot
Kedge = length(xe);

%% Create axes
% Amin = 5;
% Amax = 10;
% dA = .5;
% Ao = Amin:dA:Amax;
% Bmin = 5;
% Bmax = 10;
% dB = .5;
% Bo = Bmin:dB:Bmax;
% numA = length(Ao);
% numB = length(Bo);
% alpha = 0;

[xo,yo]= meshgrid(1:Nc,1:Nr); %%% allow any point to be center
Rmin=15; Rmax=30;  dR=0.5;      %% circles of radius 5, 5.5, .., 9
Ro=Rmin:dR:Rmax;  NumR= length(Ro);

%% ratio between a & b in ellipse
Dmin = .2; Dmax = 4; Dd = 0.1;
Do = Dmin:Dd:Dmax;
NumD = length(Do);

dconst  = 1/1.618;

votes= zeros(Nr,Nc,NumR,NumD);
for k= 1:Kedge
         R = round(dR+sqrt( (xe(k)-xo).^2+((ye(k)-yo).^2))/dconst^2)-dR;
%        R = round(dR+sqrt( (xe(k)-xo).^2+((ye(k)-yo).^2)))-dR;
        indx= find(R>=Rmin & R<=Rmax);
        for kk=1:length(indx)
            votes(yo(indx(kk)),xo(indx(kk)),(R(indx(kk))-Rmin)/dR+1)= ...
               votes(yo(indx(kk)),xo(indx(kk)),(R(indx(kk))-Rmin)/dR+1)+1;
        end
end

% for k= 1:Kedge
%         R(:,:,d) = round(dR+sqrt( (xe(k)-xo).^2+((ye(k)-yo).^2))/Do(d)^2)-dR;
%         indx= find(R(:,d)>=Rmin & R(:,d)<=Rmax);
%         for kk=1:length(indx)
%             votes(yo(indx(kk)),xo(indx(kk)),(R(indx(kk),d)-Rmin)/dR+1)= ...
%                votes(yo(indx(kk)),xo(indx(kk)),(R(indx(kk),d)-Rmin)/dR+1)+1;
%         end
% end
    
vmax= 0.99* max(votes(:));

%  figure; 

% plot(xe,ye,'r.','markersize',3)

for lr= 1:length(Ro);
    Rc= Ro(lr);
    [iv jv]= find(votes(:,:,lr)>vmax);
    for ll=1:length(iv);
        xc= xo(iv(ll),jv(ll));
        yc= yo(iv(ll),jv(ll));
        if(length(iv)<8)
            plot(xc+Rc*cosd(0:359)+bounds.minX,yc+Rc*sind(0:359)/dconst+bounds.minY,'b.','markersize',2.5); hold on
        end
    end
end

% for ld = 1:length(Do)
%     Rd = Do(ld);
%     for lr= 1:length(Ro);
%         Rc= Ro(lr);
%         [iv jv]= find(votes(:,:,lr,ld)>vmax);
%         for ll=1:length(iv);
%             xc= xo(iv(ll),jv(ll));
%             yc= yo(iv(ll),jv(ll));
%             plot(xc+Rc*cosd(0:359),yc+Rc*Rd*sind(0:359),'b.','markersize',2.5); hold on
%         end
%     end
% end

% bconst = 5;
% 
% votes = zeros(Nr,Nc,numA);
% for k = 1:Kedge
% %     B = (ye(k) - yo - (xe(k) + xo)*tan(T))/(sin(T)*cos(alpha) + sin(T)*sin(alpha)*tan(alpha));
% %     A = (xe(k)-xo-B*sin(T)*sin(alpha)) / cos(T) * cos(alpha);
% 
%     A = round(dA+sqrt((xe(k)-xo).^2+(ye(k)-yo).^2))/bconst;
%     indx = find(A>=Amin & A<=Amax);
%     for kk = 1:length(indx)
%         votes(yo(indx(kk)),xo(indx(kk)),round(indx(kk)-Amin/dA+1)) = votes(yo(indx(kk)),xo(indx(kk)),round(indx(kk)-Amin/dA+1))+1;
%     end
% end
% 
% figure;
% imshow(image);
% hold on;
% 
% plot(xe,ye,'w','markersize',3);



% (((x-h)*cos(theta)-(y-k)*sin(theta)).^2)/a^2 + (((x-h)*sin(theta) + (y-k)*cos(theta))^.2)/b^2 = 1;


end

